/*****************************************************************************
 *
 *                        CalC (Calcium Calculator)
 *                             Victor Matveev
 *
 *                                loop.h
 *
 * LoopObj variable contains data for the (nested) "for" loop script pre-processor
 * statement
 *
 ******************************************************************************/

#ifndef CALC_LOOP_H_included
#define CALC_LOOP_H_included
#define _CRT_SECURE_NO_DEPRECATE

#define MAX_FOR_STEPS 1000000

class LoopObj
{
public:

  char loopVarString[ 2048 ];

  PlotArray *plots;
  VectorObj *result;

  int       num;
  long      steps;
  long      count;
  double    fCount;
  bool      started;
  VectorObj var, var0, dvar;
  int       *index, *limit;
  char      **ids, **trackIDs, *tp;

  LoopObj(TokenString &, VectorObj *);
  ~LoopObj();
 
  int  operator()() { return num; }
  void step();
  void draw();
};

int  getTrackVarNum(TokenString &);
long getTrackVar(TokenString &TS, int n, int * = 0, int * = 0);

#endif
